const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const classes = sequelize.define(
    'classes',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

grade: {
        type: DataTypes.INTEGER,
      
      

      },

homeroom_label: {
        type: DataTypes.TEXT,
      
      

      },

active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  classes.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









    db.classes.hasMany(db.students, {
      as: 'students_current_class',
      foreignKey: {
          name: 'current_classId',
      },
      constraints: false,
    });




    db.classes.hasMany(db.class_subjects, {
      as: 'class_subjects_class',
      foreignKey: {
          name: 'classId',
      },
      constraints: false,
    });


    db.classes.hasMany(db.timetable_entries, {
      as: 'timetable_entries_class',
      foreignKey: {
          name: 'classId',
      },
      constraints: false,
    });


    db.classes.hasMany(db.attendance_sessions, {
      as: 'attendance_sessions_class',
      foreignKey: {
          name: 'classId',
      },
      constraints: false,
    });



    db.classes.hasMany(db.announcements, {
      as: 'announcements_target_class',
      foreignKey: {
          name: 'target_classId',
      },
      constraints: false,
    });










    db.classes.hasMany(db.fee_definitions, {
      as: 'fee_definitions_class',
      foreignKey: {
          name: 'classId',
      },
      constraints: false,
    });






//end loop



    db.classes.belongsTo(db.schools, {
      as: 'school',
      foreignKey: {
        name: 'schoolId',
      },
      constraints: false,
    });

    db.classes.belongsTo(db.academic_years, {
      as: 'academic_year',
      foreignKey: {
        name: 'academic_yearId',
      },
      constraints: false,
    });

    db.classes.belongsTo(db.education_levels, {
      as: 'education_level',
      foreignKey: {
        name: 'education_levelId',
      },
      constraints: false,
    });

    db.classes.belongsTo(db.users, {
      as: 'homeroom_teacher',
      foreignKey: {
        name: 'homeroom_teacherId',
      },
      constraints: false,
    });




    db.classes.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.classes.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return classes;
};


